diff --git a/lib/ethdev/rte_ethdev_telemetry.c b/lib/ethdev/rte_ethdev_telemetry.c
index ec8e48877187..5e70d0c2a66a 100644
--- a/lib/ethdev/rte_ethdev_telemetry.c
+++ b/lib/ethdev/rte_ethdev_telemetry.c
@@ -11,6 +11,29 @@
 #include "ethdev_driver.h"
 #include "sff_telemetry.h"
 
+static int
+eth_dev_parse_port_params(const char *params __rte_unused, uint16_t *port_id,
+		char **end_param, bool has_next)
+{
+	uint64_t pi;
+
+	if (params == NULL || strlen(params) == 0 ||
+		!isdigit(*params) || port_id == NULL)
+		return -EINVAL;
+
+	pi = strtoul(params, end_param, 0);
+	if (**end_param != '\0' && !has_next)
+		RTE_ETHDEV_LOG(NOTICE,
+			"Extra parameters passed to ethdev telemetry command, ignoring\n");
+
+	if (pi >= UINT16_MAX || !rte_eth_dev_is_valid_port(pi))
+		return -EINVAL;
+
+	*port_id = pi;
+
+	return 0;
+}
+
 static int
 eth_dev_handle_port_list(const char *cmd __rte_unused,
 		const char *params __rte_unused,
@@ -64,14 +87,13 @@ eth_dev_handle_port_stats(const char *cmd __rte_unused,
 		struct rte_tel_data *d)
 {
 	struct rte_eth_stats stats;
-	int port_id, ret;
-
-	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
-		return -1;
+	uint16_t port_id;
+	char *end_param;
+	int ret;
 
-	port_id = atoi(params);
-	if (!rte_eth_dev_is_valid_port(port_id))
-		return -1;
+	ret = eth_dev_parse_port_params(params, &port_id, &end_param, false);
+	if (ret < 0)
+		return ret;
 
 	ret = rte_eth_stats_get(port_id, &stats);
 	if (ret < 0)
@@ -104,17 +126,15 @@ eth_dev_handle_port_xstats(const char *cmd __rte_unused,
 	struct rte_eth_xstat *eth_xstats;
 	struct rte_eth_xstat_name *xstat_names;
 	struct rte_kvargs *kvlist;
-	int port_id, num_xstats;
 	bool hide_zero = false;
+	uint16_t port_id;
 	char *end_param;
+	int num_xstats;
 	int i, ret;
 
-	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
-		return -1;
-
-	port_id = strtoul(params, &end_param, 0);
-	if (!rte_eth_dev_is_valid_port(port_id))
-		return -1;
+	ret = eth_dev_parse_port_params(params, &port_id, &end_param, true);
+	if (ret < 0)
+		return ret;
 
 	if (*end_param != '\0') {
 		kvlist = rte_kvargs_parse(end_param, valid_keys);
@@ -166,18 +186,13 @@ eth_dev_handle_port_dump_priv(const char *cmd __rte_unused,
 			struct rte_tel_data *d)
 {
 	char *buf, *end_param;
-	int port_id, ret;
+	uint16_t port_id;
+	int ret;
 	FILE *f;
 
-	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
-		return -EINVAL;
-
-	port_id = strtoul(params, &end_param, 0);
-	if (*end_param != '\0')
-		RTE_ETHDEV_LOG(NOTICE,
-			"Extra parameters passed to ethdev telemetry command, ignoring");
-	if (!rte_eth_dev_is_valid_port(port_id))
-		return -EINVAL;
+	ret = eth_dev_parse_port_params(params, &port_id, &end_param, false);
+	if (ret < 0)
+		return ret;
 
 	buf = calloc(RTE_TEL_MAX_SINGLE_STRING_LEN, sizeof(char));
 	if (buf == NULL)
@@ -207,19 +222,14 @@ eth_dev_handle_port_link_status(const char *cmd __rte_unused,
 		struct rte_tel_data *d)
 {
 	static const char *status_str = "status";
-	int ret, port_id;
 	struct rte_eth_link link;
+	uint16_t port_id;
 	char *end_param;
+	int ret;
 
-	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
-		return -1;
-
-	port_id = strtoul(params, &end_param, 0);
-	if (*end_param != '\0')
-		RTE_ETHDEV_LOG(NOTICE,
-			"Extra parameters passed to ethdev telemetry command, ignoring");
-	if (!rte_eth_dev_is_valid_port(port_id))
-		return -1;
+	ret = eth_dev_parse_port_params(params, &port_id, &end_param, false);
+	if (ret < 0)
+		return ret;
 
 	ret = rte_eth_link_get_nowait(port_id, &link);
 	if (ret < 0)
@@ -246,19 +256,14 @@ eth_dev_handle_port_info(const char *cmd __rte_unused,
 	struct rte_tel_data *rxq_state, *txq_state;
 	char mac_addr[RTE_ETHER_ADDR_FMT_SIZE];
 	struct rte_eth_dev *eth_dev;
+	uint16_t port_id;
 	char *end_param;
-	int port_id, i;
-
-	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
-		return -1;
+	int ret;
+	int i;
 
-	port_id = strtoul(params, &end_param, 0);
-	if (*end_param != '\0')
-		RTE_ETHDEV_LOG(NOTICE,
-			"Extra parameters passed to ethdev telemetry command, ignoring");
-
-	if (!rte_eth_dev_is_valid_port(port_id))
-		return -EINVAL;
+	ret = eth_dev_parse_port_params(params, &port_id, &end_param, false);
+	if (ret < 0)
+		return ret;
 
 	eth_dev = &rte_eth_devices[port_id];
 
diff --git a/lib/ethdev/sff_telemetry.c b/lib/ethdev/sff_telemetry.c
index 5923350424c0..f29e7fa882ac 100644
--- a/lib/ethdev/sff_telemetry.c
+++ b/lib/ethdev/sff_telemetry.c
@@ -126,7 +126,7 @@ eth_dev_handle_port_module_eeprom(const char *cmd __rte_unused, const char *para
 				  struct rte_tel_data *d)
 {
 	char *end_param;
-	int port_id;
+	uint64_t port_id;
 
 	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
 		return -1;
@@ -134,7 +134,7 @@ eth_dev_handle_port_module_eeprom(const char *cmd __rte_unused, const char *para
 	errno = 0;
 	port_id = strtoul(params, &end_param, 0);
 
-	if (errno != 0) {
+	if (errno != 0 || port_id >= UINT16_MAX) {
 		RTE_ETHDEV_LOG(ERR, "Invalid argument, %d\n", errno);
 		return -1;
 	}